layui.define([ 'form', 'laydate', 'table','roleApi' ], function(exports) {
	var form = layui.form;
	var laydate = layui.laydate;
	var table = layui.table;
	var roleApi = layui.roleApi;
	var roleTable = null;
	var view ={
		
		init:function(){
			this.initTable();
			this.initSearchForm();
			this.initToolBar();
			window.dataReload = function(){
				Lib.doSearchForm($("#searchForm"),roleTable)
			}
			
			
		},
		initTable:function(){
			roleTable = table.render({
				elem : '#roleTable',
				height : Lib.getTableHeight(),
				method : 'post',
				url : Common.ctxPath + '/admin/role/list.json' //数据接口
				,page : Lib.tablePage //开启分页
				,limit : 10,
				cols : [ [ //表头
				{
					type : 'checkbox',
					fixed:'left',
				},
				{
					field : 'name',
					title : '角色名称',
					width : 120,
					sort : true
				}, {
					field : 'typeText',
					title : '角色类型',
					width : 300,
					sort : true
				},
					{
					field : 'code',
					title : '角色代码',
					width : 150
				},
				{
					field : 'createTime',
					title : '创建时间',
					width : 120,
					templet:function(d){
						return Common.getDate(d.createTime);
					},
					sort : true
				},{title: '操作', width: 260, align: "center", templet: function (d) {
					var htm = '<a class="layui-btn layui-btn-normal layui-btn-xs" lay-event="edit">编辑</a>';
					htm += '<a class="layui-btn layui-btn-normal layui-btn-xs" lay-event="roleUser">查看用户</a>';
					htm += '<a class="layui-btn layui-btn-danger layui-btn-xs" lay-event="del">删除</a>';
					return htm;
				}}

				] ]

			});
		},
		
		initSearchForm:function(){
			Lib.initSearchForm( $("#searchForm"),roleTable,form);
		},
		initToolBar:function(){
			toolbar = {
					add : function() { //获取选中数据
						var url = "/admin/role/add.do";
						Common.openDlg(url,"角色管理>新增");
					},
					edit : function() { //获取选中数目
						var data = Common.getOneFromTable(table,"roleTable");
						if(data==null){
							return ;
						}
						var url = "/admin/role/edit.do?id="+data.id;
						Common.openDlg(url,"角色管理>>编辑");
						
					},
					del : function() { 
						layui.use(['del'], function(){
							  var delView = layui.del
							  delView.delBatch();
						});
					},
					roleUser : function() { 
						var data = Common.getOneFromTable(table,"roleTable");
						if(data==null){
							return ;
						}
						var url = "/admin/role/user/list.do?roleId="+data.id;
						Common.openDlg(url,"角色管理>"+data.name+">用户列表");
						
					},search: function () {
						Lib.doSearchForm($("#searchForm"), roleTable, 1);
					}, refresh: function () {
						searchForm.reset();
						Lib.doSearchForm($("#searchForm"), roleTable, 1);
					}
					
				};
			$('.ext-toolbar').on('click', function() {
				var type = $(this).data('type');
				toolbar[type] ? toolbar[type].call(this) : '';
			});
		}, initTableTool: table.on('tool(roleTable)', function (obj) {
			var data = obj.data;
			if (obj.event === 'edit') {
				var url = "/admin/role/edit.do?id="+data.id;
				Common.openDlg(url,"角色管理>>编辑");
			}else if(obj.event === "del"){
				Common.openConfirm("是否确认要删除<span style='color: red;font-weight: bold;'>" + data.name + "</span>信息?",function(){
					roleApi.del(data.id,function(){
						Common.info("删除成功");
						Lib.tableRefresh();
					});
				})
			}else if(obj.event === "roleUser"){
				var url = "/admin/role/user/list.do?roleId="+data.id;
				Common.openDlg(url,"角色管理>"+data.name+">用户列表");
			}
		})
	}

	 exports('index',view);
	
});