layui.define([ 'form', 'laydate', 'table','roleApi','tree'], function(exports) {
	var form = layui.form;
	var laydate = layui.laydate;
	var table = layui.table;
	var tree = layui.tree;
	var zTreeObj = null;
	var ids = "";//功能点授权ID
	var mensIds = "";//菜单授权ID
	var roleApi = layui.roleApi;
	var checkedRoleId=null; //角色ID
	var view ={
		
		init:function(roleId){
			this.initFunctionTree();
			this.initSaveFunction();
			
		},
		initFunctionTree:function(){
			layer.load(3);
			var that = this;
			$.post(Common.ctxPath + "/admin/function/tree.json", {}, function(response) {
				tree.render({
					elem: '#functionTree'
					,data: response.data
					,onlyIconControl:true
					,showCheckbox: true  //是否显示复选框
					,id: 'demoId1'
					,isJump: true //是否允许点击节点时弹出新窗口跳转
					,click: function(obj){
						selectDiscoloration("functionTree");
					},oncheck: function(obj){
						selectDiscoloration("functionTree");
					}
				});
				layer.closeAll();
				that.initFirstRole();
				that.initRoles();
			});
			$.post(Common.ctxPath + "/core/user/menu/tree.json", {}, function(response) {
				tree.render({
					elem: '#menuByRoleTree'
					,data:response.data[0].children
					,onlyIconControl:true
					,showCheckbox: true  //是否显示复选框
					,id: 'demoId2'
					,isJump: true //是否允许点击节点时弹出新窗口跳转
					,click: function(obj){
						selectDiscoloration("menuByRoleTree");
					},oncheck: function(obj){
						selectDiscoloration("menuByRoleTree");
					}
				});
				layer.closeAll();
				that.initFirstRole();
				that.initRoles();
			});

		},
		initSaveFunction:function(){//绑定功能授权
			var that = this;
			// $("#save").click(function(){ //保存功能授权
			// 	ids = "";
			// 	var info = tree.getChecked('demoId1');
			// 	that.forGetId(info,1);
			// 	roleApi.saveFunctions(checkedRoleId,ids,function (){
			// 		that.loadFunctionByRole(checkedRoleId);
			// 	});
			// });
			$("#saveMenu").click(function(){ //保存菜单授权
				layer.load(3);
				mensIds = "";
				var info = tree.getChecked('demoId2');
				that.forGetId(info,2);
				roleApi.saveMenu(checkedRoleId,mensIds);
				ids = "";
				var info = tree.getChecked('demoId1');
				that.forGetId(info,1);
				roleApi.saveFunctions(checkedRoleId,ids,function (){
					layer.closeAll();
					that.loadFunctionByRole(checkedRoleId);
					Common.info("保存成功！");
				});
			});
		},
		initRoles:function(){//绑定角色点击事件
			var that = this;
			form.on('radio(roleId)', function(data){
				 checkedRoleId = data.value; //被点击的radio的value值
				 that.loadFunctionByRole(checkedRoleId);
			});
			$("#allSelect,#allSelectMenu").click(function (){//全选
				that.allSelect($(this).attr("index"));
			});
			$("#allCancel,#allCancelMenu").click(function (){//全取消
				that.allCancel($(this).attr("index"));
			});
		},
		initFirstRole:function(){//初始加载角色
			var firstRole=$(".layui-form").find(":radio")[0]
			checkedRoleId= $(firstRole).val();
			this.loadFunctionByRole(checkedRoleId);
			$(firstRole).prop("checked",true);
			form.render();
		},
		loadFunctionByRole:function(roleId){ //根据角色id查询权限并返显
			layer.load(3);
			$("#functionTree input[same='layuiTreeCheck']").prop("checked",false);
			$("#menuByRoleTree input[same='layuiTreeCheck']").prop("checked",false);
			form.render();
			roleApi.queryFunctionByRole(roleId,function(fnIds){//获取权限IDs
				layer.closeAll();
				tree.setChecked('demoId1', fnIds); //勾选指定节点
			});
			roleApi.getMenuByRoleId(roleId,function(fnIds){//获取菜单IDs
				layer.closeAll();
				tree.setChecked('demoId2', fnIds); //勾选指定节点
			});
		},forGetId:function (childrenList,index){ //获取ID
			var that = this;
			$.each(childrenList,function(n,v) {
				if(index == 1){
					if($.isEmpty(v.children)){ //为什么要这样呢？因为如果把父节点ID弄进去后返显时会直接将该父节点下所有数据都选中
						ids += v.id +",";
					}
				}else {
					if($.isEmpty(v.children)) {
						mensIds += v.id + ",";
					}
				}
				that.forGetId(v.children,index);
			});
		},allSelect:function (id){//全选
			$("#"+id+" input[same='layuiTreeCheck']").prop("checked",true);
			form.render();
		},allCancel:function (id){//全取消
			$("#"+id+" input[same='layuiTreeCheck']").prop("checked",false);
			form.render();
		}
	}

	//未全选变色
	function selectDiscoloration(id){
		$("#" + id +" .layui-tree-setHide").each(function (){
			var checkboxNum = $(this).find(".layui-form-checkbox").length; //存在多选框的个数
			if(checkboxNum > 1){
				if($(this).find(".layui-form-checkbox:eq(0)").attr("class").indexOf("layui-form-checked") >= 0){ //判断首个是否选中（父节点） 如果选中则后面的才有可能选中
					var num = $(this).find(".layui-form-checked").length; //选中的个数
					if(checkboxNum != num){
						$(this).find(".layui-form-checkbox:eq(0)").find("i").css("background-color","#bee1c8");
					}
				}
			}
		});
	}
	 exports('roleFn',view);
	
});