layui.define([ 'form', 'transfer', 'table','userApi','tree',"laytpl" ], function(exports) {
	var form = layui.form;
	var transfer = layui.transfer;
	var laytpl = layui.laytpl;
	var table = layui.table;
	var userApi=layui.userApi;
	var tree = layui.tree;
	var userTable = null;
	loadOrg();
	function loadOrg(){
		var ret = Common.postAjax("/core/user/org.json"); //加载部门数据
		if(ret.code == 0){
			var data = Lib.treeEach(ret.data);
			//开启节点操作图标
			tree.render({
				elem: '#test9'
				,data: data
				,onlyIconControl:true
				,edit: ['add', 'update', 'del'] //操作节点的图标
				,click: function(obj){
					$("#tableInfo").show();
					$("#editOrg").hide();
					userTable.reload({
						where: {orgId:obj.data.id},
						page: {
							curr: 1
						}

					});
				},operate: function(obj){
					var type = obj.type; //得到操作类型：add、edit、del
					var data = obj.data; //得到当前节点的数据
					var elem = obj.elem; //得到当前节点元素
					//Ajax 操作
					var id = data.id; //得到节点索引
					if(type === 'add'){ //增加节点
						$("#tableInfo").hide();
						$("#editOrg").show();
						data.newParentOrgName = data.title;
						data.newPparentOrgId = data.id;
						data.newId = "";
						data.newType = "";
						data.newCode = "";
						data.newName = "";

						var getTpl = editOrg_demo.innerHTML
							,view = document.getElementById('editOrg');
						laytpl(getTpl).render(data, function(html){
							view.innerHTML = html;
						});
					} else if(type === 'update'){ //修改节点
						$("#tableInfo").hide();
						$("#editOrg").show();
						data.newId = data.id;
						data.newParentOrgName = data.parentOrgName;
						data.newName = data.title;
						if(!$.isEmpty(data.org)){
							data.newType = data.org.type;
							data.newCode = data.org.code;
							data.newPparentOrgId = data.org.parentOrgId;
						}
						var getTpl = editOrg_demo.innerHTML
							,view = document.getElementById('editOrg');
						laytpl(getTpl).render(data, function(html){
							view.innerHTML = html;
							$("select[name='type']").val(data.newType);
						});
					} else if(type === 'del'){ //删除节点
						if(id != 1){
							Common.postAjax("/admin/org/delete.json",{ids:id});
							loadOrg();
						}else {
							layer.msg("删除失败！不能删除根节点！", {
								offset: ['50%'],
								icon: 2,
								time: 2000 //2秒关闭（如果不配置，默认是3秒）
							});
							loadOrg();
						}

					};
					form.render();

					// if(type === 'add'){ //增加节点
					// 	Common.postAjax("/admin/org/save.json",{parentOrgId:id,name:"未命名",code:data.name+"_"+"未命名",type:"ORGT2"}); //ORGT2:部门
					// } else if(type === 'update'){ //修改节点
					// 	Common.postAjax("/admin/org/update.json",{id:id,name:elem.find('.layui-tree-txt').html(),code:data.name});
					// } else if(type === 'del'){ //删除节点
					// 	Common.postAjax("/admin/org/delete.json",{ids:id});
					// };
					return ;
				}
			});
		}
	}

	//监听提交
	form.on('submit(formDemo)', function(data){
		layer.load(1);
		if($.isEmpty(data.field.id)){
			var ret =  Common.postAjax("/admin/org/save.json",data.field);
			layer.msg(ret.code == 0?"添加成功！":ret.msg, {
				offset: ['50%'],
				icon: ret.code == 0?1:2,
				time: 2000 //2秒关闭（如果不配置，默认是3秒）
			});
		}else {
			var ret = Common.postAjax("/admin/org/update.json",data.field);
			layer.msg(ret.code == 0?"修改成功！":ret.msg, {
				offset: ['50%'],
				icon: ret.code == 0?1:2,
				time: 2000 //2秒关闭（如果不配置，默认是3秒）
			});
		}
		layer.closeAll("loading");
		$("#tableInfo").show();
		$("#editOrg").hide();
		loadOrg();
		return false;
	});


	var view ={
		
		init:function(){
			this.initTable();
			this.initSearchForm();
			this.initToolBar();
			window.dataReload = function(){
				Lib.doSearchForm($("#searchForm"),userTable)
			}
			
			
		},
		initTable:function(){
			userTable = table.render({
				elem : '#userTable',
				height : Lib.getTableHeight(),
				method : 'post',
				url : Common.ctxPath + '/admin/user/list.json' //数据接口
				,page : Lib.tablePage //开启分页
				,limit : 10,
				cols : [ [ //表头
				{
					type : 'checkbox',
					fixed:'left',
				}
				, {
					field : 'code',
					title : '用户名',
					width : 150
				}, {
					field : 'name',
					title : '姓名',
					width : 120,
					sort : true
				}, {
					field : 'orgName',
					title : '部门',
					sort : true
				},
				{   field : 'stateText', title : '状态',width : 120,align: "center",templet: '#switch_goods_Tpl'},
				 {
					field : 'jobType0Text',
					title : '职位',
					align : "center",
					sort : true
				},
				 {
					field : 'jobType1Text',
					title : '职位明细',
					align : "center",
					sort : true
				},
				{
					field : 'createTime',
					title : '创建时间',
					align : "center",
					width : 120,
					templet:function(d){
						return Common.getDate(d.createTime);
					},
					sort : true
				},{title: '操作', width: 280, align: "center",style:"text-align: left;",templet: function (d) {
					var htm = '<a class="layui-btn layui-btn-normal layui-btn-xs" lay-event="edit">编辑</a>';
							htm += '<a class="layui-btn layui-btn-normal layui-btn-xs" lay-event="userRole">角色分配</a>';
							htm += '<a class="layui-btn layui-btn-normal layui-btn-xs" lay-event="changePassword">修改密码</a>';
							if(parent.$("#userId").val() != d.id){
								htm += '<a class="layui-btn layui-btn-danger layui-btn-xs" lay-event="del">删除</a>';
							}
					return htm;
				}}
				] ]

			});
		},
		
		initSearchForm:function(){
			Lib.initSearchForm( $("#searchForm"),userTable,form);
		},
		initToolBar:function(){
			toolbar = {
					add : function() { //获取选中数据
						var url = "/admin/user/add.do";
						Common.openDlg(url,"用户管理>新增");
					},
					search: function () {
						Lib.doSearchForm($("#searchForm"), userTable, 1);
					},
					refresh: function () {
						searchForm.reset();
						Lib.doSearchForm($("#searchForm"), userTable, 1);
					},
					del : function() { 
						layui.use(['del'], function(){
							  var delView = layui.del
							  delView.delBatch();
						});
					},
					userRole : function() { //获取选中数目
						var data = Common.getOneFromTable(table,"userTable");
						if(data==null){
							return ;
						}
						var url = "/admin/user/role/list.do?id="+data.id;
						Common.openDlg(url,"用户管理>"+data.name+">角色管理");
					},
					changePassword:function(){
						var data = Common.getOneFromTable(table,"userTable");
						if(data==null){
							return ;
						}
						var url = "/admin/user/changePassword.do?id="+data.id;
						Common.openDlg(url,"用户管理>更改密码");

					},
					exportUsers:function(){
					    Common.openConfirm("确认要导出这些用户?",function(){
					        userApi.exportUsers($("#searchForm"),function(fileId){
					           Lib.download(fileId);
					        })
		                })

                    }
				};
			$('.ext-toolbar').on('click', function() {
				var type = $(this).data('type');
				toolbar[type] ? toolbar[type].call(this) : '';
			});
		}, initTableTool: table.on('tool(userTable)', function (obj) {
			var data = obj.data;
			if (obj.event === 'edit') {
				var url = "/admin/user/edit.do?id="+data.id;
				Common.openDlg(url,"用户管理>编辑");
			}else if(obj.event === "del"){
				Common.openConfirm("是否确认要删除<span style='color: red;font-weight: bold;'>" + data.name + "</span>信息?",function(){
					userApi.del(data.id,function(){
						Common.info("删除成功");
						Lib.tableRefresh();
					});
				})
			}else if(obj.event === "changePassword"){
				var url = "/admin/user/changePassword.do?id="+data.id;
				Common.openDlg(url,"用户管理>更改密码");
			}else if(obj.event === "userRole"){
				// var url = "/admin/user/role/list.do?id="+data.id;
				// Common.openDlg(url,"用户管理>"+data.name+">角色管理");
				loadUserRole(data.id,!$.isEmpty(data.roleIds)?data.roleIds.split(","):[]);
			}
		})
	}

	//加载所有角色信息
	function loadUserRole(userId,roleIds){
		var ret = Common.getAjax("/admin/role/all.json");
		var data = [];
		if(ret.code == 0){
			data = ret.data;
		}
		layer.open({
			type: 1,
			title: "角色信息",
			shadeClose: true,
			btn: ['确定', '关闭'],
			btnAlign: 'c',
			area: ['550px', '500px'],
			content: $("#userRole_dialog"),
			success: function (layero, index) {
				transfer.render({
					elem: '#test1'
					,data:data
					,title: ['未选角色', '已选角色']
					,id:"key123"
					,parseData: function(res){
						return {
							"value": res.id //数据值
							,"title": res.name //数据标题
							,"disabled": res.disabled  //是否禁用
							,"checked": res.checked //是否选中
						}
					},
					value:roleIds
				});
			}, yes: function (index) {
				var getData = transfer.getData('key123'); //获取右侧数据
				var roleIds = Common.concatBatchId(getData,"value");
				var ret = Common.postAjax("/admin/user/role/addAll.json",{userId:userId,roleIds:roleIds});
				if(ret.code == 0){
					layer.msg(ret.code == 0?"操作成功！":ret.msg, {
						offset: ['50%'],
						icon: ret.code == 0?1:2,
						time: 1500 //2秒关闭（如果不配置，默认是3秒）
					},function (){
						if(ret.code == 0){
							Lib.tableRefresh();
							layer.close(index);
						}
					});
				}
			}, btn2: function (index, layero) {
				layer.close(index);
			}
		});
	}

	//监听状态切换
	form.on('switch(goodsIsState)', function (obj) {
		var state = "S0";
		if (obj.elem.checked) {
			state = "S1";
		}
		var ret = Common.postAjax("/admin/user/update.json",{id:obj.value,state:state});
		if(ret.code == 0){
			Common.info("修改成功！");
			Lib.tableRefresh();
		}
	});


	 exports('index',view);
	
});